CON
  _clkmode = xtal1 + pll16x 
  _xinfreq = 5_000_000

 

OBJ
  lcd  : "Nokia3310"

  pst  : "Parallax Serial Terminal"
  spiLock : "Lock"

VAR                              
  byte SPILockNum


PUB Main | i, lastUpdate
  'if(DEBUG)
   ' pst.Start(115_200)
  'pst.str(String("Starting..."))
  
  SPILockNum := locknew

  spiLock.getLockNow
  i := \sd.mount_explicit(10, 11, 12, 13)                                'Mount SD Card
  spiLock.clrLock
  if(i <> 0)
    repeat
         
  lcd.InitR(8, SPILockNum)

  lcd.clear
  lcd.str(String("Playing..."))
  'NewMain
'  pst.str(String("Playing..."))
  'SPILock.getLockNow
  'sd.mount(10)
  'SPILock.clrLock
  Main2(@sFilename)
  'sd.unmount         
 ' pst.str(String("Done."))

  lcd.cursorXY(0,1)
  lcd.str(String("Done."))

  repeat
    i++ 
  

CON

  attenuation = 0  '  <----  increase this number a little to reduce volume, if desired (0..3 is about the useful range).
  buffSize = 100   'Size of wav data buffers
                                                  

VAR long parameter1  'to pass @buff1 to ASM
    long parameter2  'to pass @buff2 to ASM
    long parameter3  'to pass sample rate to ASM
    long parameter4  'to pass #samples to ASM
    long buff1[buffSize]
    long buff2[buffSize]
    byte Header[44]

    long PlayStack[100]
    
OBJ
    sd  : "fsrw"   'Controls the SD card 
    'text : "PSM_tv_text"    'display text on PSM LCD
    text : "parallax serial terminal"

DAT
  ' sFilename byte "BibS44.wav"         '   <---------  Change .wav filename here !!!!!!!!!!!!!!
   sFilename byte "mshot.wav"         '   <---------  Change .wav filename here !!!!!!!!!!!!!!
   byte 0


PUB NewMain
  CogNew(Main2(@sFilename), @PlayStack) 
   

PUB Main2(Filename)|n,i,j, SampleRate,Samples

  'Play a WAV File
  'Start up the status display...
 
  'open the WAV file  (NOTE:  Only plays stereo, 16-bit PCM WAV Files !!!!!!!!!!!!!)
  'access SD card

  
  
 ' i:=sd.mount_explicit(10,11,12,13)
  'i:=sd.mount(12)           
  'if (i<>0)
   '  repeat

   SPILock.getLockNow

  'open file
  i:=sd.popen(Filename, "r")              
  if (i<>0)
    repeat

  
    
  'ignoring much file header (so you better have the format right!)    stereo, 16-bit PCM WAV Files !!!!!!!!!!!!!!!!
  'See here for header format:  http://ccrma.stanford.edu/CCRMA/Courses/422/projects/WaveFormat/
  i:=sd.pread(@Header, 44) 'read data words to input stereo buffer
  'Get sample rate from header
  SampleRate:=Header[27]<<24+Header[26]<<16+Header[25]<<8+Header[24]
  'text.out(13)
  'get # samples from header
  Samples:=Header[43]<<24+Header[42]<<16+Header[41]<<8+Header[40]
  Samples:=Samples>>2
  'text.out(13)
    

  'Start ASM player in a new cog
  
   
  parameter1:=@buff1[0]
  parameter2:=@buff2[0]
  parameter3:=CLKFREQ/SampleRate  '#clocks between samples'1814'for 44100ksps,  5000 'for 16ksps
  parameter4:=Samples
  COGNEW(@ASMWAV,@parameter1)

  'Keep filling buffers until end of file
  ' note:  using alternating buffers to keep data always at the ready...
  n:=buffSize-1
  buff1[n]:=0  'clear filled flags at end of buffers
  buff2[n]:=0
  i:=n*4   'number of bytes to read
  j:=i
  repeat while (j==i)  'repeat until end of file
    if (buff1[n]==0)
      j:=sd.pread(@buff1, i) 'read data words to input stereo buffer
      buff1[n]:=1 'set filled flag   

    if (buff2[n]==0)
      j:=sd.pread(@buff2, i) 'read data words to input stereo buffer
      buff2[n]:=1 'set filled flag

  'must have reached the end of the file, so close it
  sd.pclose

  SPILock.clrLock
         

DAT
  ORG 0
ASMWAV
'load input parameters from hub to cog given address in par
        movd    :par,#pData1             
        mov     tx,par
        mov     ty,#4  'input 4 parameters
:par    rdlong  0,tx
        add     :par,dlsb
        add     tx,#4
        djnz    ty,#:par

setup
        'setup output pins
        MOV DMaskR,#1
        ROL DMaskR,OPinR
        OR DIRA, DMaskR
'        MOV DMaskL,#1
'        ROL DMaskL,OPinL
'        OR DIRA, DMaskL
        'setup counters
        OR CountModeR,OPinR
        MOV CTRA,CountModeR
'        OR CountModeL,OPinL
'        MOV CTRB,CountModeL
        'Wait for SPIN to fill table
        MOV WaitCount, CNT
        ADD WaitCount,BigWait
        WAITCNT WaitCount,#0
        'setup loop table
        MOV LoopCount,SizeBuff  
        'ROR LoopCount,#1    'for stereo
        MOV pData,pData1
        MOV nTable,#1
        'setup loop counter
        MOV WaitCount, CNT
        ADD WaitCount,dRate


MainLoop
        SUB nSamples,#1
        CMP nSamples,#0 wz
        IF_Z JMP #Fin
        waitcnt WaitCount,dRate

        RDLONG Right,pData
'        MOV   Left,Right
'        SAR   Right,#attenuation
'        ROL Left,#16       '16 LSBs are left channel...
'        SAR   Left,#attenuation
        ADD Right,twos      'Going to cheat a bit with the LSBs here...  Probably shoud fix this!
 '       Add Left,twos
        MOV FRQA,Right
        
 '       MOV FRQB,Left'Right
        'WRLONG Zero,pData
        ADD pData,#4
        
        'loop
        DJNZ LoopCount,#MainLoop

        WRLONG Zero,pData  'clear filled flag 
        
        MOV LoopCount,SizeBuff        
        'switch table       ?
        CMP nTable,#1 wz
        IF_Z JMP #SwitchToTable2
SwitchToTable1
        MOV nTable,#1
        MOV pData,pData1
        JMP #MainLoop
SwitchToTable2
        MOV nTable,#2
        MOV pData,pData2
        JMP #MainLoop
        
                
Fin
         'now stop
        COGID thisCog
        COGSTOP thisCog          

'Working variables
thisCog long 0
tx       long 0
ty       long 0
dlsb    long    1 << 9
BigWait long 100000
twos    long $8000_8000
        
'Loop parameters
nTable  long 0
WaitCount long 0
pData   long 0
LoopCount long 0
SizeBuff long (buffsize-1)
'Left    long 0
Right   long 0
'Left    long 0
Zero    long 0          

'setup parameters
DMaskR  long 0 'right output mask
OPinR   long 25 'right channel output pin #                        '   <---------  Change Right pin# here !!!!!!!!!!!!!!    
'DMaskL  long 0 'left output mask 
'OPinL   long 10 'left channel output pin #                         '   <---------  Change Left pin# here !!!!!!!!!!!!!!    
CountModeR long %00011000_00000000_00000000_00000000
CountModeL long %00011000_00000000_00000000_00000000


'input parameters
pData1   long 0 'Address of first data table        
pData2   long 0 'Address of second data table
dRate    long 5000  'clocks between samples
nSamples long 2000
